generic
	-- Tipo de los elementos a alamacenar
	type TElemento is private;

	-- Capacidad de la cola
	Capacidad: Positive := 63;

	-- Operacin para evaluar la prioridad de los elementos
	-- debe devolver true cuando la prioridad de X es mayor que la de Y
	with function MayorPrioridad(X, Y: TElemento) return Boolean;

package Colas_De_Prioridad is
	type Cola is limited private;
	-- Representa una cola con prioridad
	-- Cuando se declaran, las variables de tipo Cola tienen tamao cero

	procedure Insertar(C: in out Cola; E: in TElemento);
	-- Aade el elemento E a la cola C siempre que Tamao(C) sea menor
	-- que Capacidad, en caso contrario produce un Constraint_Error

	procedure Extraer(C: in out Cola);
	-- Extrae el elemento de mayor prioridad de la cola C siempre que
	-- Tamao(C) no sea cero, si no produce un Constraint_Error

	function Examinar(C: in Cola) return TElemento;
	-- Devuelve el elemento de mayor prioridad de la cola C siempre que
	-- Tamao(C) no sea cero, si no produce un Constraint_Error

	procedure Vaciar(C: in out Cola);
	-- Vaca la cola C, dejndola con tamao cero

	function Tamao(C: in cola) return Natural;
	-- Devuelve el tamao de la cola C

private
	-- Los elementos de la cola se almacenan en un vector que se
	-- gestiona con poltica de montculo
	type Montculo is array(1..Capacidad) of TElemento;
	type Cola is record
		Elementos: Montculo;
		Tamao   : natural := 0;
	end record;
end Colas_De_Prioridad;
