with Unchecked_Deallocation;

generic
	with function "<"(X,Y: in TElemento) return boolean is <>;
package Contenedores.rboles_Binarios is
	-- Tipo contenedor implementado con un rbol binario de bsqueda.
	type Binario_Bsqueda is new Contenedor with private;
		-- Los contenedores se crean vacos.

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Binario_Bsqueda; E: in TElemento);
		-- Aade el elemento E al contenedor C, si no est ya presente
		-- Si E est en C no hace nada.

	procedure Extraer(C: in out Binario_Bsqueda; E: in TElemento);
		-- Se quita el elemento E del contenedor C. Si E no est en C,
		-- no hace nada

	procedure Vaciar(C: in out Binario_Bsqueda);
		-- Vaca el contenedor C, dejndolo sin elementos

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in Binario_Bsqueda; E: in TElemento) return Boolean;
		-- Devuelve True si el elemento E est en el contenedor C
		-- y False si no

	function Tamao(C: in Binario_Bsqueda) return Natural;
		-- Devuelve el nmero de elementos del contenedor C.
	
private
	-- Estructura del rbol binario de bsqueda
	type Nodo_Binario;
	type rbol_Bin_Bus is access all Nodo_Binario;
	type Lista_Hijos is array(1..2) of rbol_Bin_Bus;
	type Nodo_Binario is record
		Clave: TElemento;
		Hijos: Lista_Hijos; --Hijos(1) = hijo izqdo
		                    --Hijos(2) = hijo drcho
	end record;

	-- Estructura del contenedor
	type Binario_Bsqueda is new Contenedor with record
		Elementos: rbol_Bin_Bus;
	end record;

	procedure Eliminar is new
		Unchecked_Deallocation(Nodo_Binario, rbol_Bin_Bus);
end Contenedores.rboles_Binarios;
