generic
	type Parte_clave is (<>);
	type Clave_Completa is array(Positive range <>) of Parte_Clave;
	with function Clave(E: in TElemento) return clave_completa is <>;
		-- Debe proporcionar un valor de clave diferente para
		-- elementos diferentes
package Contenedores.Tries is
	type Trie is new Contenedor with private;

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Trie; E: in TElemento);
		-- Aade el elemento E al contenedor C, si no est ya presente.
		-- Si E est en C no hace nada.

	procedure Extraer(C: in out Trie; E: in TElemento);
		-- Se quita el elemento E del contendor C. Si E no est en C,
		-- no hace nada.

	procedure Vaciar(C: in out Trie);
		-- Vaca el contenedor C, dejndolo sin elementos.

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in Trie; E: in TElemento) return boolean;
		-- Devuelve True si el elemento E est en el contendor C
		-- y False si no.

	function Tamao(C: in Trie) return Natural;
		-- Devuelve el nmero de elementos del contenedor C.

private
	-- Clase del nodo
	type Tipo_nodo is (Desviacin, Informacin);

	-- Estructura nodal del trie
	type Nodo_Trie;
	type Rbol_Trie is access Nodo_trie;

	type Lista_Enlaces is array(Parte_Clave) of rbol_Trie;

	type Nodo_trie(Tipo: Tipo_Nodo) is record		
		case Tipo is
			when Desviacin => enlaces: Lista_Enlaces;
			                   Final  : rbol_Trie(Informacin);
			when Informacin=> Info   : TElemento;
		end case;
	end record;

	type Trie is new Contenedor with record
		Elementos: Rbol_Trie;
	end record;
end Contenedores.Tries;
