with Unchecked_Deallocation;
package body Rbol_Bin is
	function Modificar(T:rbol; E:TElemento; T1,T2:rbol) return rbol is
	begin
		T.Info     := E;  -- Se cambia la informacin de la raz de T
		T.Hijos(1) := T1; -- Se cambia el subrbol izquierdo de T
		T.Hijos(2) := T2; -- Se cambia el subrbol derecho de T
		return T;
	exception
		when Constraint_Error => raise rbol_Vaco;
	end Modificar;

	function Crear(E: TElemento; T1, T2: rbol) return rbol is
	begin  
		-- Se crea un rbol nuevo juntando E, T1 y T2
		return new Nodo'(E, (T1, T2));
	end Crear;

	function Es_Vaco(T: rbol) return Boolean is
	begin
		return T = null;
	end Es_Vaco;

	function Raz(T: rbol) return TElemento is
	begin
		if T /= null then
			return T.Info;
		else
			raise rbol_Vaco;
		end if;
	end Raz;

	function Izquierdo(T: rbol) return rbol is
	begin
		if T /= null then
			return T.Hijos(1);
		else
			raise rbol_Vaco;
		end if;
	end Izquierdo;

	function Derecho(T: rbol) return rbol is
	begin
		if T /= null then
			return T.Hijos(2);
		else
			raise rbol_Vaco;
		end if;
	end Derecho;

	procedure Liberar is new Unchecked_Deallocation(Nodo, rbol);
	procedure Vaciar(T: in out rbol) is
		Aux: Rbol;
	begin
		if T /= null then
			Vaciar(T.Hijos(1));
			Vaciar(T.Hijos(2));
			Aux := T;
			T := null;
			Liberar(Aux);
		end if;
	end Vaciar;


	function Copia(T: rbol) return rbol is
	begin
		if T = null then
			return Vaco;
		else
			return Crear(T.Info, Copia(T.Hijos(1)), Copia(T.Hijos(2)));
		end if;
	end Copia;

	--Falta completar las funciones Es_Vaco, Raz e Izquierdo
end rbol_Bin;
