package contenedores;

/**
 * Interfaz general para la implementacin de contenedores
 * asociativos simples.
 */
public interface Contenedor {
	/**
	 * @param e, elemento a insertar en el contenedor, si est no hace nada.
	 */
	public void insertar(Object e);

	/**
	 * @param e, elemento a quitar del contenedor. Si no est no hace nada.
	 */
	public void extraer(Object e);

	/**
	 * Vaca el contenedor, dejndolo sin elementos.
	 */
	public void vaciar();

	/**
	 * @param e, elemento a buscar en el contenedor.
	 * @return true si encuentra el elemento buscado.
	 */
	public boolean est(Object e);

	/**
	 * @return true si el contenedor est vaco y false si no.
	 */
	public boolean esVaco();

	/**
	 * @return el nmero de elementos del contenedor.
	 */
	public int tamao();
}
