package rbolesBinarios;
/**
 * Implementacin de un rbol binario
 */
public class rbolBinario 
{
	/*
	 * Componente bsico del rbol
	 */
	class Nodo 
	{
		Object info;
		rbolBinario hijos[] = new rbolBinario[2];
	}
	
	Nodo rbol;
	
	/**
	 * Inicializa un rbol vaco
	 */
	public rbolBinario() 
	{
		rbol = null;
	}
	
	/**
	 * Inicializa un rbol con info como raz e izqdo y drcho
	 * como subrboles
	 */
	public rbolBinario(Object info, rbolBinario izqdo,
		rbolBinario drcho) 
	{
		rbol = new Nodo();
		rbol.info =  info;
		rbol.hijos[0] = izqdo;
		rbol.hijos[1] = drcho;
	}

	/**
	 * Modifica un rbol poniendo info como raz e izqdo y drcho
	 * como subrboles
	 * (si el rbol est vaco, se produce una NullPointerException)
	 */
	public void modificar(Object info, rbolBinario izqdo,
		rbolBinario drcho) 
	{
		rbol.info =  info;
		rbol.hijos[0] = izqdo;
		rbol.hijos[1] = drcho;
	}
	
	/**
	 * @return la informacin de la raz de this
	 * (si el rbol est vaco, se produce una NullPointerException)
	 */
	public Object raz() 
	{
		return rbol.info;
	}
	
	/**
	 * @return el subrbol izquierdo de this
	 * (si el rbol est vaco, se produce una NullPointerException)
	 */
	public rbolBinario izquierdo() 
	{
		return rbol.hijos[0];
	}

	/**
	 * @return el subrbol derecho de this
	 * (si el rbol est vaco, se produce una NullPointerException)
	 */
	public rbolBinario derecho() 
	{
		return rbol.hijos[1];
	}
	
	/**
	 * @return true si el rbol est vaco
	 */
	public boolean esVaco() 
	{
		return rbol == null;	
	}
}
