#ifndef INC_CONTENEDOR
#define INC_CONTENEDOR
   #include <exception>
   #include <string>
   using namespace std;
   class excepcionContenedor: public exception{
      string razon;
   public:
      excepcionContenedor(string s){razon=s;}
      ~excepcionContenedor() throw() {}
      const char* what() const throw(){return razon.c_str();}	
   };

template <class T>
class Contenedor {
   public:
   // Constructoras
      virtual ~Contenedor(){}; // Destructor por defecto

      /**
       * Inserta un elemento en el contenedor, si est no hace nada. 
       */
      virtual void insertar(const T &) = 0;

      /**
       * Extrae un elemento del contenedor, si no est no hace nada
       */
      virtual void extraer(const T &) = 0;

      /**
       * Vaca el contenedor dejndolo sin elementos
       */
      virtual void vaciar() = 0;

   // Observadoras
      /**
       * Localiza un elemento en el contenedor
       */
      virtual bool encuentra(const T &) const = 0;

      /**
       * Devuelve verdadero si el contenedor no est vaco
       */
      virtual bool hayElementos() const {return cardinal() != 0;}

      /**
       * Devuelve el nmero de elementos almacenados en el contenedor
       */
      virtual int cardinal() const = 0;
};

template <class T>
   class ContenedorPersistente:public Contenedor<T> {
   public:
      virtual void crear(const char *) = 0;
      virtual void abrir(const char *) = 0;
      virtual void cerrar() = 0;
   };

#endif

